import { GenericObject } from "../interfaces";

interface Unload {
    /**
     * Registers a function to be triggered when window.onunload fires.
     * Deprecated, use on(window, "unload", lang.hitch(obj, functionName)) instead.
     */
    addOnWindowUnload(obj: GenericObject | Function, functionName?: string | Function): void;

    /**
     * Registers a function to be triggered when the page unloads.
     * Deprecated, use on(window, "beforeunload", lang.hitch(obj, functionName))
     */
    addOnUnload(obj: GenericObject | Function, functionName?: string | Function): void;
}

declare module "./kernel" {
    interface Dojo {
        /**
     * Registers a function to be triggered when window.onunload fires.
     * Deprecated, use on(window, "unload", lang.hitch(obj, functionName)) instead.
     */
        addOnWindowUnload(obj: GenericObject | Function, functionName?: string | Function): void;

        /**
         * Registers a function to be triggered when the page unloads.
         * Deprecated, use on(window, "beforeunload", lang.hitch(obj, functionName))
         */
        addOnUnload(obj: GenericObject | Function, functionName?: string | Function): void;
    }
}

declare const Unload: Unload;
export = Unload;